<template>
	<el-main>
		<el-row :gutter="15">
			<el-col :xl="6" :lg="6" :md="8" :sm="12" :xs="24">
				<el-card class="task task-add" shadow="never" @click="add">
					<el-icon><el-icon-plus /></el-icon>
					<p>添加计划任务</p>
				</el-card>
			</el-col>
			<el-col :xl="6" :lg="6" :md="8" :sm="12" :xs="24" v-for="item in list" :key="item.id">
				<el-card class="task task-item" shadow="hover">
					<h2>{{item.title}}</h2>
					<ul>
						<li>
							<h4>执行类</h4>
							<p>{{ item.type }}</p>
						</li>
						<li>
							<h4>定时规则</h4>
							<p>{{item.schedule}} <code>({{ item.executetime }})</code></p>
						</li>
					</ul>
					<div class="bottom">
						<div class="state">
							<el-tag v-if="item.status=='1'" size="small">准备就绪</el-tag>
							<el-tag v-if="item.status=='0'" size="small" type="info">停用</el-tag>
						</div>
						<div class="handler">
							<el-popconfirm title="立即执行吗？" @confirm="run(item)">
								<template #reference>
									<el-button type="primary" icon="el-icon-caret-right" circle></el-button>
								</template>
							</el-popconfirm>
							<el-dropdown trigger="click">
								<el-button type="primary" icon="el-icon-more" circle plain></el-button>
								<template #dropdown>
									<el-dropdown-menu>
										<el-dropdown-item @click="edit(item)">编辑</el-dropdown-item>
										<el-dropdown-item @click="logs(item)">日志</el-dropdown-item>
										<el-dropdown-item @click="crontabdelete(item)" divided>删除</el-dropdown-item>
									</el-dropdown-menu>
								</template>
							</el-dropdown>
						</div>
					</div>
				</el-card>
			</el-col>
		</el-row>
	</el-main>

	<save-dialog v-if="dialog.save" ref="saveDialog" @success="handleSuccess" @closed="dialog.save=false"></save-dialog>
	<el-drawer :title=" loginfo.title + '计划任务日志'" v-model="dialog.logsVisible" :size="600" direction="rtl" destroy-on-close>
		<logs ref="logs"></logs>
	</el-drawer>
</template>

<script>
	import saveDialog from './save'
	import logs from './logs'

	export default {
		name: 'crontab',
		components: {
			saveDialog,
			logs
		},
		provide() {
			return {
				list: this.list
			}
		},
		data() {
			return {
				dialog: {
					save: false,
					logsVisible: false
				},
				list: [],
				loginfo:{},
				logslist: []
			}
		},
		mounted() {

			this.loaddata();

		},
		methods: {
			loaddata(){
				this.$http.get('app/crontab/lists').then((res) => {
				    if (res.code == 200) {
				    	this.list = res.data;
				    	return ;
				    }

				    this.$alert(res.message, "提示", {type: 'error'});
				});
			},
			add(){
				this.dialog.save = true
				this.$nextTick(() => {
					this.$refs.saveDialog.open()
				})
			},
			edit(task){
				this.dialog.save = true
				this.$nextTick(() => {
					this.$refs.saveDialog.open('edit').setData(task)
				})
			},
			crontabdelete(task){
				this.$confirm(`确认删除 ${task.title} 计划任务吗？`,'提示', {
					type: 'warning',
					confirmButtonText: '删除',
					confirmButtonClass: 'el-button--danger'
				}).then(() => {


					this.$http.get('app/crontab/delete').then((res) => {
					    if (res.code == 200) {
					    	this.list.splice(this.list.findIndex(item => item.id === task.id), 1)
					    	return ;
					    }

					    this.$alert(res.message, "提示", {type: 'error'});
					});



				}).catch(() => {
					//取消
				})
			},
			logs(o){
				this.loginfo = o;
				this.dialog.logsVisible = true
				this.$nextTick(() => {
					this.$refs.logs.setApi('app/crontab/logs?id='+o.id)
				})
			},
			run(task){
				this.$message.success(`已成功执行计划任务：${task.title}`)
			},
			//本地更新数据
			handleSuccess(data, mode){

				this.$http.post('app/crontab/submit',  {type:mode, info:data}).then((res) => {


					this.$refs.saveDialog.isSaveing = false;
						
					if (res.code == 200 ) {

						if (res.data && res.data.id) {
							if(mode=='add'){
								this.list.push(data)
							}else if(mode=='edit'){
								this.list.filter(item => item.id===data.id ).forEach(item => {
									Object.assign(item, data)
								})
							}						
						}else{
							this.loaddata({})
						}

						this.$refs.saveDialog.visible = false;
						this.$message.success(res.message || "操作成功")
						return;
					}
					this.$alert(res.message||'错误', "提示", {type: 'error'});
	            })
			}
		}
	}
</script>

<style scoped>
	.task {height: 210px;}
	.task-item h2 {font-size: 15px;color: #3c4a54;padding-bottom:15px;}
	.task-item li {list-style-type:none;margin-bottom: 10px;}
	.task-item li h4 {font-size: 12px;font-weight: normal;color: #999;}
	.task-item li p {margin-top: 5px;}
	.task-item .bottom {border-top: 1px solid #EBEEF5;text-align: right;padding-top:10px;display: flex;justify-content: space-between;align-items: center;}
	.task-add {display: flex;flex-direction: column;align-items: center;justify-content: center;text-align: center;cursor: pointer;color: #999;}
	.task-add:hover {color: #409EFF;}
	.task-add i {font-size: 30px;}
	.task-add p {font-size: 12px;margin-top: 20px;}
	.dark .task-item .bottom {border-color: var(--el-border-color-light);}
</style>
